/*
Lab Batch 26
Main Game Code
*/

#include<iostream>
#include<string>
#include<cstdlib>
#include<ctime>
#include<cstdio>
#include"assert.h"
#include"bitmap.h"
#include"rect.h"
#include"label.h"
#include"circle.h"
#include"position.h"
#include"ezwin.h"
#include"wobject.h"
#include"shape.h"
#include"label.h"
#include <time.h>
#include <termios.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <sys/time.h>


using namespace std;

#ifndef STDIN_FILENO
#define STDIN_FILENO 0
#endif


struct termios tty_set_raw();
void tty_restore(struct termios oldstuff);
int linux_getch(void);
int linux_kbhit(void);

/*****************************************/

SimpleWindow PaddleGame("Paddle Game",28.0,18.0,Position(0.0,0.0));			//main game window created

/*****************************************/


char in('w');                         							//user input
unsigned ticknumber = 0;								// to track score

/*****************************************/

//all numbers are in cgs

float ballx(5), bally(5);								//current x and y co ordinates of the ball
float vx(1), vy(0.2);									//current x and y velocities of the ball
const float xmax(27.3), xmin(0.7), ymin(0.7), ymax(15.3);				//the table max min co ordinates
const float rad(0.35);                                          			//radius of the ball                                               
float padmid(1.7);                                              			//y co ordinate of the middle of comp's paddle
float  lt(2);                                               				//paddle length of CPU  paddle
float lt2(2);						   				//paddle length of user paddle
float H_play(100), H_comp(100);								// for paddle health updation 
int k;
const float vy_max(0.4);								// Maximum vertical velocity of ball
const float vy_min(0.15);								//minimum vertical velocity of ball
const float vx_max(1.5);								// maximum horizontal velocity of ball
int powerFlag(0);									//flag to determine if CPU has been awarded with a special power
int powerFlag1(0);									//flag to determine if user has been awarded with a special power								
const float x1(11);						
const float x2(17);
                                                                                        // determine area of special power dispensation
int flag=1;										// flag to enable excecution of special power by user input
//variables needed for AI

float t_total;                                                     			//approx time required by the ball to reach from current position to comp end
float padv;                                                       			//comp paddle velocity
float bally_strike;                                                			//y co ordinate at which the ball will strike the comp end
float t_hstrike;                                                   			//time(from the current ball pos) @ which ball will strike the horizontal walls
float ballx_hstrike, bally_hstrike;                               			//x and y co ordinate @ which ball will strike the horizontal walls
float t_left;       

/******************************************/


void executePower(int n)
{
        PaddleGame.RenderText(Position(xmax-.5,ymin-.25), "1", White, White);
        PaddleGame.RenderText(Position(xmax-.5,ymin-.25), "2", White, White);
        PaddleGame.RenderText(Position(xmax-.5,ymin-.25), "3", White, White);

    if(n=1){
        
        switch(powerFlag1)
        {
            case 1: vx=-vx;
                    break;
            case 2: lt2+=1;
                    if(lt2>4)
                        lt2=4;
                    break;
            case 3: lt-=.5;
                    if(lt<1)
                        lt=1;
                    break;
            default:break;
        }
        powerFlag1=1;
    }
    if(n=0){
    switch(powerFlag){
            case 1: vx=-vx;
                    break;
            case 2: lt+=1;
                    if(lt>4)
                        lt=4;
                    break;
            case 3: lt2-=.5;
                    if(lt2<1)
                        lt=1;
                    break;
            default:break;
        }
        powerFlag=1;
    }

}


void health()
{

if (ballx<1 && k==1){ H_comp= H_comp-20; k=0;}

if (ballx>27 && k==1){ H_play=H_play-20; k=0;}
}

/****************************************/
                                                                    //radius of the ball                                               
float padmid2(5);                                                   //y co ordinate of the middle of comp's paddle

//variables needed for AI

float t_total2;                                                     //approx time required by the ball to reach from current position to comp end
float padv2;                                                        //comp paddle velocity
float bally_strike2;                                                //y co ordinate at which the ball will strike the comp end
float t_hstrike2;                                                   //time(from the current ball pos) @ which ball will strike the horizontal walls
float ballx_hstrike2, bally_hstrike2;                               //x and y co ordinate @ which ball will strike the horizontal walls

float t_left2;       

/*****************************************/

void delay(double t)
{
clock_t start, end;
start=clock();
while(double (clock()-start) <t)				    // 1000000 for delay of 1 second
{
}
}

/********************************************/

void allotPower()
{
    srand((unsigned)time(0)); 
    int i;
    i = (rand()%3)+1; 
    if(vx>0){
        PaddleGame.RenderText(Position(xmin+.5,ymin-.25), "1", White, White);
        PaddleGame.RenderText(Position(xmin+.5,ymin-.25), "2", White, White);
        PaddleGame.RenderText(Position(xmin+.5,ymin-.25), "3", White, White);
        powerFlag=i;
        flag=0;
    }
    else{
        PaddleGame.RenderText(Position(xmax-.5,ymin-.25), "1", White, White);
        PaddleGame.RenderText(Position(xmax-.5,ymin-.25), "2", White, White);
        PaddleGame.RenderText(Position(xmax-.5,ymin-.25), "3", White, White);
        cout<<"alloted power to u"<<endl;
        powerFlag1=i;
        flag=0;
        switch(i){
        
            case 1: PaddleGame.RenderText(Position(xmax-.5,ymin-.25), "1", Blue, White);
                    break;
            case 2: PaddleGame.RenderText(Position(xmax-.5,ymin-.25), "2", Blue, White);
                    break;
            case 3: PaddleGame.RenderText(Position(xmax-.5,ymin-.25), "3", Blue, White);
                    break;
            default: ;
        }


    }
    

}



float absol(float x)                                                 					//function to get the absolute of a number
{
      if (x<0) return -x;
      if (x>=0) return x;
}



/********************************************/



void ballMove()
{
    ballx+=vx*0.1;
    bally+=vy*0.1;
       
    if((bally-rad/2<ymin)||(bally+rad/2>ymax-0.1)) 							 //when ball hits h wall
    {
        vy = -1*vy;     
        if(ballx< x2 && ballx> x1)
            if( (!powerFlag && vx>0) || (!powerFlag1 && vx<0) )
                  allotPower();
    }
    if((ballx-rad/2<xmin+0.1)||(ballx+rad/2>xmax-0.1)) {vx = -1*vx;}                                     //when ball hits v wall  
        
    
    if((ballx<xmin+0.8)&&(bally<padmid+lt/2)&&(bally>padmid-lt/2)) 					//when ball hits paddle1
    {
        if(vx<vx_max)
            vx=-1.001*vx;
        vy+= absol(vy)*8*(bally-padmid)/lt;
        if(vy<0 && vy > -vy_min)
            vy= -vy_min;
        if(vy>0 && vy<vy_min)
            vy= vy_min; 
        if(vy>vy_max)
            vy=vy_max;
        if(vy< - vy_max)
            vy= -vy_max;
    }         
    if((ballx>xmax-0.8)&&(bally<padmid2+lt2/2)&&(bally>padmid2-lt2/2)) 
    {
        if(vx<vx_max)
            vx=-1.001*vx;
        vy+= 8*absol(vy)*(bally-padmid)/lt2;
        if(vy<0 && vy > -vy_min)
            vy= -vy_min;
        if(vy>0 && vy<vy_min)
            vy= vy_min;
        if(vy>vy_max)
            vy=vy_max;
        if(vy< - vy_max)
            vy= -vy_max;
    }
        
    //when ball hits paddle2

}
/***************************************/
void paddleMove()
{
t_total = absol((ballx - xmin)/vx);
              
if ((t_total*absol(vy))<(ymax - bally))               		//the ball will not strike the horizontal walls
{ 
      bally_strike = bally + (vy*t_total);
      padv = (bally_strike - padmid)/t_total;
}

          
if ((t_total*absol(vy))>(ymax - bally))               		//the ball will strike the horizontal walls
{
       if (vy<0) bally_hstrike = ymin;
       if (vy>0) bally_hstrike = ymax;
                    
       t_hstrike = ymax-bally/vy;
       ballx_hstrike = ballx - (vx*t_hstrike);
       t_left = (ballx_hstrike - (xmin+0.3))/vx;                //assuming padmid is at xmin + 0.3
       bally_strike = bally_hstrike + (vy*t_left);              
       padv = (bally_strike - padmid)/t_left;
		  			
}

if(vx<0)
{
padmid+=padv*0.1;					//ai

if(padmid-lt/2<ymin)
padmid = ymin+1;

if(padmid+lt/2>ymax)
padmid = ymax-1;
}
}


/*****************************************/


void paddle2Move(int c)
{
if(c==0x6a)
{
    if(!flag){
	executePower(1);
        flag=1;
    }
}


if(c==0x77)
{
padmid2-=0.1;

if(padmid2-lt2/2<ymin)		
padmid2 = ymin+lt2/2;		

if(padmid2+lt2/2>ymax)		
padmid2 = ymax-lt2/2;
}

if(c==0x73)
{
padmid2+=0.1;

if(padmid2-lt2/2<ymin)		
padmid2 = ymin+lt2/2;

if(padmid2+lt2/2>ymax)		
padmid2 = ymax-lt2/2;
}

if(c==0x20) padmid2 = padmid2;



        PaddleGame.RenderRectangle(Position(xmax-0.8,padmid2-lt2/2), Position(xmax-0.3,padmid2+lt2/2), Black,false);     	        //render paddle2 
        delay(10000);
        PaddleGame.RenderRectangle(Position(xmax-0.8,padmid2-lt2/2), Position(xmax-0.3,padmid2+lt2/2), Red,false);     	        	//render paddle2 


}




int ApiMain()
{
    
    int kb_char;
    time_t now;
    struct termios save_attr;
    int i;
    
    cout<<"WELCOME TO THE PADDLE BALL GAME"<<endl<<endl;

    now = time(0);

    i = 0;
    save_attr = tty_set_raw();
    
    PaddleGame.Open();
    assert(PaddleGame.GetStatus() == WindowOpen);

//board
    PaddleGame.RenderRectangle(Position(xmin,ymin), Position(xmax,ymax), Red, false); 

    int ctr=0;

    while (1) {
        usleep(1);            /* keep from hogging cpu time  */
        if (time(0) != now) { /* show something every second */
            {now = time(0);
            ++ticknumber;}
        }
        else if (linux_kbhit()) {
            kb_char = linux_getch();
            if (kb_char == EOF) {
                printf("EOF\n");
                break;
            }
            if (kb_char == 0x03) {
                printf("Ctrl-C breaks out of the loop\n");
                break;
            }
            if (isprint(kb_char)) {
                printf("'%c'", kb_char);
            }
            else {
                printf("   ");
            }
            printf(" (%02x hex)\n", kb_char);
        }
        
        in=kb_char;
        ballMove();
        paddleMove();        
        if(ballx>1.7 && ballx<26.3)k=1;
            health();    
            
        
        PaddleGame.RenderRectangle(Position(21,15.5), Position(21+(H_play/20),16), Green, true);             //player health

        PaddleGame.RenderRectangle(Position(4,15.5), Position(4+(H_comp/20),16), Green, true);                //computer health
        
        PaddleGame.RenderRectangle(Position(x1,ymin-.2), Position(x2, ymin), Yellow, true);  
        
        PaddleGame.RenderRectangle(Position(x1,ymax), Position(x2, ymax+.2), Yellow, true);  


        
        PaddleGame.RenderRectangle(Position(xmin+0.3,padmid-lt/2), Position(xmin+0.8,padmid+lt/2), Black,false);     	        //render paddle
        PaddleGame.RenderEllipse( Position(ballx-rad/2,bally-rad/2),Position(ballx+rad/2, bally+rad/2), Blue, false);    	//render ball           
        paddle2Move(kb_char);
        PaddleGame.RenderEllipse( Position(ballx-rad/2,bally-rad/2),Position(ballx+rad/2, bally+rad/2), Red, false);   		//erase ball
        PaddleGame.RenderRectangle(Position(xmin+0.3,padmid-lt/2), Position(xmin+0.8,padmid+lt/2), Red,false);           	//erase paddle  
        
        PaddleGame.RenderRectangle(Position(7+(H_comp)/20,15.5), Position(12,16), White, true);    
        PaddleGame.RenderRectangle(Position(21+(H_play)/20,15.5), Position(26,16), White, true);    
        
        
       
        if(H_play ==0)
        {
            PaddleGame.RenderText(Position(14,9), "GAME OVER \n YOUR SCORE IS VISIBLE ON THE TERMINAL", White, Red);
        }
            
    }//end of while loop
    
    tty_restore(save_attr);
    
    return 0;
}
int ApiEnd()
{
        cout<<"\n\nYOU SCORE: "<<ticknumber<<"\n\n";
}

int linux_kbhit()
{
    struct timeval tv = {0,0}; /* set one microsecond timeout */
    fd_set rdfds;
    int retval;

    FD_ZERO(&rdfds);
    FD_SET(STDIN_FILENO, &rdfds);

    if (select(STDIN_FILENO + 1, &rdfds, NULL, NULL, &tv) == -1) {
        perror("select");
        exit(1);
    }
    if (FD_ISSET(STDIN_FILENO, &rdfds)) {
        retval = 1;
    }
    else {
        retval = 0;
    }
    return retval;
}

struct termios tty_set_raw()
{
    struct termios oldstuff;
    struct termios newstuff;

    tcgetattr(STDIN_FILENO, &oldstuff);/* save old attributes          */
    newstuff = oldstuff;
    /* 
     * Resetting these flags will set the terminal to raw mode.
     * Note that ctrl-c won't cause program exit, so there
     * is no emergency panic escape. (If your calling program
     * doesn't handle things properly, you will have to kill
     * the process externally.)
     */
    newstuff.c_lflag &= ~(ICANON | ECHO | IGNBRK);

    tcsetattr(STDIN_FILENO, TCSANOW, &newstuff);/* set new attributes  */
    return oldstuff;
}

void tty_restore(struct termios oldstuff)
{
    tcsetattr(STDIN_FILENO, TCSANOW, &oldstuff);/* restore old attributes */
}

#define END_FILE_CHARACTER 0x04 /* ctrl-d is unix-style eof input key */

/* 
 * Waits until a key has been pressed, then reads.
 * Since this is "raw" mode, EOF is a special case
 *
 * This can be used in the same program where the tty has been
 * set to "no-wait".
 *
 */
int linux_getch(void)
{
    char inch;
    int num_chars;

    do {
        num_chars = read(0, &inch, 1);
    } while (num_chars < 1);

    if (inch == END_FILE_CHARACTER) {
        inch = EOF;
    }

    return inch;
}
